package com.trs.ggzyexchange.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 采矿权招拍挂公告信息
 * </p>
 *
 * @author trs
 * @since 2024-01-04
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ZrzyCkqNotice extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 数据唯一标识（来源系统）
     */
    @TableId("SOURCE_DATA_KEY")
    private String sourceDataKey;

    /**
     * 数据来源系统的编码
     */
    @TableField("SOURCE_DATA_CODE")
    private String sourceDataCode;

    /**
     * 矿山名称
     */
    @TableField("NA_APP_NAME")
    private String naAppName;

    /**
     * 公告发布时间
     */
    @TableField("NOTICE_SEND_TIME")
    private Long noticeSendTime;

    /**
     * 公告结束时间
     */
    @TableField("NOTICE_END_TIME")
    private Long noticeEndTime;

    /**
     * 统一交易标识码
     */
    @TableField("UNIFIED_DEAL_CODE")
    private String unifiedDealCode;

    /**
     * 公告编号
     */
    @TableField("NOTICE_CODE")
    private String noticeCode;

    /**
     * 公告名称
     */
    @TableField("NOTICE_NAME")
    private String noticeName;

    /**
     * 公告内容
     */
    @TableField("ANNOUNCEMENT_CONNECT")
    private String announcementConnect;

    /**
     * 公告性质
     */
    @TableField("NOTICE_NATURE")
    private String noticeNature;

    /**
     * 公告源URL
     */
    @TableField("URL")
    private String url;

    /**
     * 出让方式
     */
    @TableField("IN_BUY_KIND")
    private Long inBuyKind;

    /**
     * 采矿权底价
     */
    @TableField("CK_RESERVE_PRICE")
    private BigDecimal ckReservePrice;

    /**
     * 底价金额单位
     */
    @TableField("CK_RESERVE_PRICE_UINT")
    private String ckReservePriceUint;

    /**
     * 矿种
     */
    @TableField("IN_MINE_COME")
    private Long inMineCome;

    /**
     * 出让年限
     */
    @TableField("QT_PLAN_YEARS")
    private BigDecimal qtPlanYears;

    /**
     * 面积
     */
    @TableField("QT_TOTAL_AREA")
    private BigDecimal qtTotalArea;

    /**
     * 地理位置
     */
    @TableField("NA_GEOGRAPHY_POSITION")
    private String naGeographyPosition;

    /**
     * 项目所在行政区域代码
     */
    @TableField("REGION_CODE")
    private String regionCode;

    /**
     * 交易发生行政区域代码
     */
    @TableField("TRA_PLACE_CODE")
    private String traPlaceCode;

    /**
     * 交易机构名称
     */
    @TableField("TRA_AGENCY_NAME")
    private String traAgencyName;

    /**
     * 交易机构代码
     */
    @TableField("TRA_AGENCY_CODE")
    private String traAgencyCode;

    /**
     * 区域坐标
     */
    @TableField("NA_AREA_COORDINATE")
    private String naAreaCoordinate;

    /**
     * 交易系统标识码
     */
    @TableField("PLATFORM_CODE")
    private String platformCode;

    /**
     * 交易服务系统标识码
     */
    @TableField("PUB_SERVICE_PLAT_CODE")
    private String pubServicePlatCode;

    /**
     * 数据时间戳
     */
    @TableField("DATA_TIMESTAMP")
    private Long dataTimestamp;

    /**
     * 交易中心编码
     */
    @TableField("DATA_SOURCE_CODE")
    private String dataSourceCode;


}
