package com.trs.ggzyexchange.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 探矿权招拍挂结果公示信息
 * </p>
 *
 * @author trs
 * @since 2024-01-04
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ZrzyTkqBidwinnotice extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 数据唯一标识（来源系统）
     */
    @TableId("SOURCE_DATA_KEY")
    private String sourceDataKey;

    /**
     * 数据来源系统的编码
     */
    @TableField("SOURCE_DATA_CODE")
    private String sourceDataCode;

    /**
     * 项目编号
     */
    @TableField("NA_APP_CODE")
    private String naAppCode;

    /**
     * 项目名称
     */
    @TableField("NA_APP_NAME")
    private String naAppName;

    /**
     * 统一交易标识码
     */
    @TableField("UNIFIED_DEAL_CODE")
    private String unifiedDealCode;

    /**
     * 发布时间
     */
    @TableField("PUBLISHING_TIME")
    private Long publishingTime;

    /**
     * 公告源URL
     */
    @TableField("URL")
    private String url;

    /**
     * 公告性质
     */
    @TableField("NOTICE_NATURE")
    private String noticeNature;

    /**
     * 出让方式
     */
    @TableField("IN_BUY_KIND")
    private Long inBuyKind;

    /**
     * 出让年限
     */
    @TableField("QT_PLAN_YEARS")
    private BigDecimal qtPlanYears;

    /**
     * 面积
     */
    @TableField("QT_TOTAL_AREA")
    private BigDecimal qtTotalArea;

    /**
     * 地理位置
     */
    @TableField("NA_GEOGRAPHY_POSITION")
    private String naGeographyPosition;

    /**
     * 项目所在行政区域代码
     */
    @TableField("REGION_CODE")
    private String regionCode;

    /**
     * 交易发生行政区域代码
     */
    @TableField("TRA_PLACE_CODE")
    private String traPlaceCode;

    /**
     * 交易机构名称
     */
    @TableField("TRA_AGENCY_NAME")
    private String traAgencyName;

    /**
     * 交易机构代码
     */
    @TableField("TRA_AGENCY_CODE")
    private String traAgencyCode;

    /**
     * 竞得人名称
     */
    @TableField("NA_PUBLIC_BIDDER")
    private String naPublicBidder;

    /**
     * 竞得人类别
     */
    @TableField("BIDDER_TYPE")
    private String bidderType;

    /**
     * 竞得人代码
     */
    @TableField("BIDDER_CODE")
    private String bidderCode;

    /**
     * 竞得人角色
     */
    @TableField("BIDDER_ROLE")
    private String bidderRole;

    /**
     * 成交价
     */
    @TableField("QT_PUBLIC_PRICE")
    private BigDecimal qtPublicPrice;

    /**
     * 竞得人公司地址
     */
    @TableField("NA_REG_ADDRESS")
    private String naRegAddress;

    /**
     * 成交地点
     */
    @TableField("NA_TD_ADDRESS")
    private String naTdAddress;

    /**
     * 成交时间
     */
    @TableField("DT_BUY_DATE")
    private Long dtBuyDate;

    /**
     * 出让收益缴纳方式
     */
    @TableField("IN_COST_STYLE")
    private Long inCostStyle;

    /**
     * 出让收益缴纳时间
     */
    @TableField("DT_COST_DATE")
    private Long dtCostDate;

    /**
     * 区域坐标
     */
    @TableField("NA_AREA_COORDINATE")
    private String naAreaCoordinate;

    /**
     * 公告标题
     */
    @TableField("ANNOUNCEMENT_NAME")
    private String announcementName;

    /**
     * 公告内容
     */
    @TableField("ANNOUNCEMENT_CONNECT")
    private String announcementConnect;

    /**
     * 交易系统标识码
     */
    @TableField("PLATFORM_CODE")
    private String platformCode;

    /**
     * 交易服务系统标识码
     */
    @TableField("PUB_SERVICE_PLAT_CODE")
    private String pubServicePlatCode;

    /**
     * 数据时间戳
     */
    @TableField("DATA_TIMESTAMP")
    private Long dataTimestamp;

    /**
     * 起始价
     */
    @TableField("START_PRICE")
    private BigDecimal startPrice;

    /**
     * 底价
     */
    @TableField("FLOOR_PRICE")
    private BigDecimal floorPrice;

    /**
     * 交易中心编码
     */
    @TableField("DATA_SOURCE_CODE")
    private String dataSourceCode;


}
