package com.trs.ggzyexchange.schedul;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.entity.*;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.enums.JobLock;
import com.trs.ggzyexchange.service.*;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Component
public class NmResultNoticeSchedul implements Job {

    @Autowired
    private ScheduledTashService scheduledTashService;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private NmResultNoticeService nmResultNoticeService;


    @Autowired
    private TRegionService tRegionService;

    private Logger logger = LoggerFactory.getLogger(NmResultNotice.class);

    public void queryPageListUpdateEs() throws JsonProcessingException {
        /**
         * 查询当前在定时任务表当中的最新时间
         */
        QueryWrapper<ScheduledTash> scheduledTashQueryWrapper = new QueryWrapper<ScheduledTash>();
        scheduledTashQueryWrapper.eq("table_name_value","nm_result_notice");
        Page<ScheduledTash> pageScheduledTash = new Page<ScheduledTash>(1, 1);
        Page<ScheduledTash> page = scheduledTashService.page(pageScheduledTash, scheduledTashQueryWrapper);
        List<ScheduledTash> records = page.getRecords();
        ScheduledTash scheduledTash = null;
        if(records.size() > 0){
            scheduledTash = records.get(0);
        }
        Long time = null;
        if(ObjectUtils.isEmpty(scheduledTash)){
            try {
                /**
                 * 如果scheduledTash为空，证明没有当前定时任务，设置当前的定时任务的时间为0  查询表gcNoticeandfile表当中的最新时间
                 */
                time = nmResultNoticeService.maxDataTimeStamp();
                ScheduledTash scheduledTashTash = new ScheduledTash();
                scheduledTashTash.setTime(0L);
                time = 0L;
                scheduledTashTash.setTableNameValue("nm_result_notice");
                scheduledTashTash.setUpdateTime(new Date());
                scheduledTashTash.setCreateTime(new Date());
                scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
            }catch (Exception e){
                e.printStackTrace();
            }
        }else {
            /**
             * 如果scheduledTash为空，证明没有当前定时任务，设置当前的定时任务的时间为0  查询表gcNoticeandfile表当中的最新时间
             */
            time = scheduledTash.getTime();
        }
        try {
            //查询表gcNoticeandfile表当中的最新时间
            Long newTime = nmResultNoticeService.maxDataTimeStamp();
            ScheduledTash scheduledTashTash = new ScheduledTash();
            scheduledTashTash.setTime(newTime);
            scheduledTashTash.setTableNameValue("nm_result_notice");
            scheduledTashTash.setUpdateTime(new Date());
            scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }

        if(!ObjectUtils.isEmpty(time)){
            try {
                QueryWrapper<NmResultNotice> gcPerformanceQueryWrapper = new QueryWrapper<NmResultNotice>();
                gcPerformanceQueryWrapper.gt("DATA_TIMESTAMP",time);
                int count = nmResultNoticeService.count(gcPerformanceQueryWrapper);
                Integer pageSize = 1000;
                Integer pageNum = (int)Math.ceil((double)count/pageSize);
                for(int i = 1; i <= pageNum;i++){
                    try {
                        List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize,time);
                        Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }

    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize,Long time){
        Page<GcTenderbidfile> page = new Page<GcTenderbidfile>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage =   nmResultNoticeService.queryNmResultNoticeAllListByTime(page,time);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            record.setTransactionTypeCode(ClassIfy.ELECTRICITY_TRADING.getCode());
            record.setTransactionTypeName(ClassIfy.ELECTRICITY_TRADING.getName());
            record.setNoticeTypeCode(ClassIfy.ELECTRICITY_NMRESULT_NOTICE.getCode());
            record.setNoticeTypeName(ClassIfy.ELECTRICITY_NMRESULT_NOTICE.getName());
            record.setPlatformName("内蒙古公共资源交易平台");
            //获取国标区域名称
            QueryWrapper<TRegion> tRegionQueryWrapper = new QueryWrapper<TRegion>();
            String TregionCode = record.getRegionCode();
            Page<TRegion> pageTRegion = new Page<TRegion>(1, 1);
            if(!ObjectUtils.isEmpty(TregionCode)){
                if(TregionCode.equals("150000")){
                    record.setRegionName("内蒙古自治区本级");
                }
                tRegionQueryWrapper.eq("code",TregionCode+"000000");
                List<TRegion> records = tRegionService.page(pageTRegion, tRegionQueryWrapper).getRecords();
                if(records.size() >= 1){
                    try {
                        String name = records.get(0).getName();
                        if(!ObjectUtils.isEmpty(name)){
                            record.setRegionName(name);
                        }
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
            TenderDetailsVoUtils.isNull(record);
        }
        return tenderDetailsVoIPage.getRecords();
    }

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        try {
            if(JobLock.NmResultNoticeFlag){
                JobLock.NmResultNoticeFlag = false;
                logger.info("执行NmResultNotice", new SimpleDateFormat().format(new Date()));
                try {
                    queryPageListUpdateEs();
                } catch (Exception e) {
                    e.printStackTrace();
                }
                JobLock.NmResultNoticeFlag = true;
            }else{
                logger.info("不执行NmResultNotice", new SimpleDateFormat().format(new Date()));
            }
        }catch (Exception e){
            e.printStackTrace();
            JobLock.NmResultNoticeFlag = true;
        }
    }
}
