package com.trs.ggzyexchange.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.trs.ggzyexchange.entity.AreaPlatform;
import com.trs.ggzyexchange.mapper.AreaPlatformMapper;
import com.trs.ggzyexchange.service.AreaPlatformService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 地区编码对照表 服务实现类
 * </p>
 *
 * @author trs
 * @since 2023-02-17
 */
@Service
public class AreaPlatformServiceImpl extends ServiceImpl<AreaPlatformMapper, AreaPlatform> implements AreaPlatformService {


    @Autowired
    private AreaPlatformMapper areaPlatformMapper;

    @Override
    public AreaPlatform getAreaPlatformByRegionCode(String regionCode) {
        if(!ObjectUtils.isEmpty(regionCode)){
            String substring = null;
            boolean bstartsWith = regionCode.startsWith("152501");
            boolean bstartsWithMZL = regionCode.startsWith("150781");
            if(bstartsWith){
                substring = regionCode.substring(0,6);
            }else if(bstartsWithMZL){
                substring = regionCode.substring(0,6);
            }else if(regionCode.length() > 4) {
                substring = regionCode.substring(0, 4);
            }
/*            if(regionCode.length() > 4){
                substring = regionCode.substring(0, 4);
            }*/
            if(!ObjectUtils.isEmpty(substring)){
                QueryWrapper<AreaPlatform> areaPlatformQueryWrapper = new QueryWrapper<AreaPlatform>();
                areaPlatformQueryWrapper.likeRight("area_code",substring);
                List<AreaPlatform> areaPlatformList = areaPlatformMapper.selectList(areaPlatformQueryWrapper);
                if(areaPlatformList.size() >= 1){
                    return areaPlatformList.get(0);
                }
            }else{
                return null;
            }
        }
        return null;
    }
}
